package org.openjdk.shenandoah.wip;

import org.openjdk.jmh.annotations.*;

import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;

@Warmup(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Measurement(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Fork(1)
@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.NANOSECONDS)
@Threads(1)
@State(Scope.Benchmark)
public class ReadWriteBarriers {

    AtomicInteger ai;

    @Setup
    public void setup() {
        ai = new AtomicInteger();
    }

    @Benchmark
    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
    public Object cas() {
        AtomicInteger ai = this.ai;
        int cur = ai.get();
        return ai.compareAndSet(cur, cur + 1);
    }

    @Benchmark
    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
    public Object incrAndGet() {
        return ai.incrementAndGet();
    }

}
